---
title: Syntax sections
slug: MDN/Structures/Syntax_sections
tags:
  - API
  - CSS
  - HTML
  - MDN Meta
  - Structure
  - Syntax
  - onboarding
---
<div>{{MDNSidebar}}</div>

<p class="summary">The syntax section of an MDN reference page contains a syntax box defining the exact syntax that a feature has (e.g. what parameters can it accept, which ones are optional?) This article explains how to write syntax boxes for refererence articles.</p>

<h2 id="API_reference_syntax">API reference syntax</h2>

<p>Syntax sections for API reference pages are written manually, and they differ depending on which page type includes them. Yet, all have things in common. In each case the section is titled "Syntax", and included at the top of the reference page, just below the introductory material.</p>

<p>In addition, each syntax section starts with a "code" block showing the feature's exact syntax, styled using the "Syntax Box" block style:</p>

<pre class="syntaxbox notranslate">A syntax block example</pre>

<h3 id="General_style_rules">General style rules</h3>

<p>A few rules to follow in terms of markup within the syntax block:</p>

<ul>
 <li>Do <em>not</em> use {{HTMLElement("code")}} within the syntax block (or within any code sample block on MDN, either). Not only is it generally useless, but our markup does not want it, and will not render the way you want it to look if you include it.</li>
 <li>
  <p>All programmer-specified content in a syntax block should be italicized using {{HTMLElement("em")}} (the "Italic" button in the editor toolbar):</p>

  <pre class="syntaxbox notranslate"><em>responseStr</em> = <em>element</em>.querySelector(<em>selector</em>);</pre>

  <p>Here, <code>responseStr</code> is the return value (a variable named by the developer), <code>element</code> is a placeholder for the variable referencing an {{DOMxRef("Element")}} object, and <code>selector</code> is the placeholder for an input parameter to the method.</p>

  <p>You may find some pages where <code>&lt;var&gt;</code> is used instead of <code>&lt;em&gt;</code>; this is also OK, but we generally prefer <code>&lt;em&gt;</code>.</p>
 </li>
</ul>

<h3 id="Constructors_and_methods">Constructors and methods</h3>

<h4 id="Syntax_block">Syntax block</h4>

<p>Start with a syntax block, like this (see the {{DOMxRef("IntersectionObserver.IntersectionObserver", "IntersectionObserver constructor")}} page):</p>

<pre class="syntaxbox notranslate">var <em>observer</em> = new IntersectionObserver(<em>callback</em>, <em>options</em>);</pre>

<p>or this (see {{DOMxRef("WindowOrWorkerGlobalScope.fetch")}}):</p>

<pre class="syntaxbox notranslate"><em>promiseResponse</em> = fetch(<em>input</em>, <em>init</em>);</pre>

<p>Sometimes syntax is written using formal syntax notation, for example see the following on {{jsxref("Array.prototype.slice()")}}:</p>

<pre class="syntaxbox notranslate">arr.slice([begin[, end]])</pre>

<p>The square brackets mean that the enclosed parameter is optional. We prefer to not use these as they confuse many of our readers. You could instead just omit the square brackets and explain that these parameters are optional in the <em>Parameters</em> section found below the syntax block.</p>

<h5 id="Multiple_lines">Multiple lines</h5>

<p>Sometimes you'll want to include multiple lines, because the method can be used in different forms. For example, see this example ({{DOMxRef("CanvasRenderingContext2D.drawImage")}}):</p>

<pre class="syntaxbox notranslate">void <em>ctx</em>.drawImage(<em>image</em>, <em>dx</em>, <em>dy</em>);
void <em>ctx</em>.drawImage(<em>image</em>, <em>dx</em>, <em>dy</em>, <em>dWidth</em>, <em>dHeight</em>);
void <em>ctx</em>.drawImage(<em>image</em>, <em>sx</em>, <em>sy</em>, <em>sWidth</em>, <em>sHeight</em>, <em>dx</em>, <em>dy</em>, <em>dWidth</em>, <em>dHeight</em>);</pre>

<p>The <code>slice()</code> syntax example could be rewritten like so, to show all possible variations and make it arguably easier to understand:</p>

<pre class="syntaxbox notranslate"><var>arr</var>.slice()<var>
arr</var>.slice(<var>begin</var>)
<var>arr</var>.slice(<var>begin</var>, <var>end</var>)</pre>

<p>Another good multiple line example is found on the {{jsxref("Date")}} constructor page, which has many quite different possibilities for its parameters:</p>

<pre class="syntaxbox notranslate">new Date();
new Date(<var>value</var>);
new Date(<var>dateString</var>);
new Date(<var>year</var>, <var>monthIndex</var> [, <var>day</var> [, <var>hours</var> [, <var>minutes</var> [, <var>seconds</var> [, <var>milliseconds</var>]]]]]);
</pre>

<p>Although as mentioned above, we could omit the square brackets and make optional status of parameters clear in the <em>Parameters</em> section.</p>

<h5 id="Concise_syntax_blocks">Concise syntax blocks</h5>

<p>The aim is to make the syntax block as pure and unambiguous as definition of the feature's syntax as possible — don't include any irrelevant syntax. For example, you may see this syntax form used to describe promises in many places on the site:</p>

<pre class="syntaxbox notranslate"><em>caches</em>.match(<em>request</em>, <em>options</em>).then(function(<em>response</em>) {
  // Do something with the response
});</pre>

<p>But this version is much more concise, and doesn't include the superfluous {{JSxRef("Promise.prototype.then()")}} method call:</p>

<pre class="syntaxbox notranslate"><em>promiseResponse</em> = <em>caches</em>.match(<em>request</em>, <em>options</em>);</pre>

<h4 id="Parameters_section">Parameters section</h4>

<p>Next, include a "Parameters" subsection, which explains what each parameter should be, in a description list. Parameters that are objects containing multiple members can include a nested description list, which itself includes an explanation of what each member should be. Optional parameters should be marked with an \{{optional_inline}} macro call next to their name in the description term.</p>

<p>The name of each parameter in the list should be contained in a {{HTMLElement("code")}} block.</p>

<div class="note">
<p><strong>Note</strong>: If the feature does not take any parameters, you don't need to include a "Parameters" section, but you can if you wish include it with content of "None".</p>
</div>

<h4 id="Return_value_section">Return value section</h4>

<p>Next, include a "Return value" subsection, which explains what the return value of the constructor or method is, even if it is <code>undefined</code>. See the above links for examples.</p>

<h4 id="Exceptions_section">Exceptions section</h4>

<p>Finally, include an "Exceptions" subsection, which explains what exceptions can be thrown if a problem is encountered when invoking the constructor/method. This could be because a parameter name has been misspelled or it has been given a value of the wrong datatype, because there is problem with the environment it is being invoked in (e.g. trying to run a secure context-only feature in a non-secure context), or some other reason.</p>

<p>Determining what exceptions are thrown by a method can require a good perusal of the specification. Looking through the spec's step-by-step explanation of how a feature operates will generally provide a solid list of the exceptions and the situations that cause them to be thrown.</p>

<p>The exception names and explanations should be included in a description list.</p>

<div class="note">
<p><strong>Note</strong>: If no exceptions can be raised on the feature, you don't need to include an "Exceptions" section, but you can if you wish include it with content of "None".</p>
</div>

<h3 id="Properties">Properties</h3>

<h4 id="Syntax_block_2">Syntax block</h4>

<p>Start with a syntax block, like this (see {{DOMxRef("IntersectionObserver.root")}}):</p>

<pre class="syntaxbox notranslate"><var>var <em>root</em> = IntersectionObserver</var>.root;</pre>

<p>For a non-read-only property, it is a good idea to include two lines, which show getting and setting the property (see {{DOMxRef("AudioParam.value")}}):</p>

<pre class="syntaxbox notranslate"><em>gain</em> = <em>gainNode</em>.gain.value;
<em>gainNode</em>.gain.value = 0;</pre>

<h4 id="Value_section">Value section</h4>

<p>Below the syntax block you need to include a "Value" subsection, which cotains a explanation of the property's value — both its data type and what its purpose is.</p>

<h4 id="Exceptions_section_2">Exceptions section</h4>

<p>If accessing the property can throw an exception, include an "Exceptions" subsection explaining each exception; this should be set up just like the one described for methods and constructors above.</p>

<h3 id="Event_handlers">Event handlers</h3>

<p>Event handler properties are still properties, but they have some differences in their syntax sections.</p>

<h4 id="Syntax_block_3">Syntax block</h4>

<p>Start with a syntax block, like this (see {{DOMxRef("Window.onvrdisplaypresentchange")}}):</p>

<pre class="syntaxbox notranslate"><em>window</em>.onvrdisplaypresentchange = <em>functionRef</em>;</pre>

<p>And that's it — event handler properties are always settable, and always contain a function, therefore no more information is needed.</p>

<h2 id="JavaScript_reference_syntax">JavaScript reference syntax</h2>

<p>JavaScript built-in object reference pages follow the same basic rules as API reference pages, e.g. for methods and properties. There are a few differences that you might observe:</p>

<ul>
 <li>For built-in objects with a single constructor, the constructor syntax is often included on the object landing page. See {{JSxRef("Date")}} for example. You'll notice that static methods (those that exist on the <code>Date</code> object itself) are listed under "Methods", whereas instance methods are listed under "Date.prototype methods".</li>
 <li>You'll also notice that methods that have no parameters/exceptions are more likely to have those subsections not included at all on JavaScript rerefence pages. See {{JSxRef("Date.getDate()")}} and {{JSxRef("Date.now()")}} for examples.</li>
</ul>

<h2 id="CSS_reference_syntax">CSS reference syntax</h2>

<h3 id="Properties_2">Properties</h3>

<p>CSS property reference pages include a "Syntax" section, which used to be found at the top of the page but is increasingly commonly found below a section containing a block of code showing typical usage of the feature, plus a live example to illustrate what the feature does (see {{CSSxRef("animation")}} for example).</p>

<div class="note">
<p><strong>Note</strong>: We do this because CSS formal syntax is complex, not used by many of the MDN readership, and offputting for beginners. Real syntax and examples are more useful to the majority of people.</p>
</div>

<p>Inside the syntax section you'll find the following contents.</p>

<h4 id="Optional_explanation_text">Optional explanation text</h4>

<p>Some CSS properties are self-explanatory and don't really need extra explanation (for example {{CSSxRef("color")}}). Some on the other hand are more complex and need explanation on syntax order, including multiple values, etc. (see {{CSSxRef("animation")}}). In such cases you can include extra explanation before any of the subsections.</p>

<h4 id="Values_section">Values section</h4>

<p>Next, you should include a "Values" section — this contains a description list explaining the CSS value types that make up the value of the property. Each value type should be wrapped in angle brackets and linked to the MDN reference page covering that value type if a page exists for it. For example, see the {{CSSxRef("border")}} property reference — this reference three value types, only one of which is linked ({{CSSxRef("&lt;color&gt;")}}).</p>

<h4 id="Formal_syntax">Formal syntax</h4>

<p>the last section, "Formal syntax", is automatically generated from the data included in the <a href="https://github.com/mdn/data">MDN data repo</a>'s CSS directory. You just need to include a {{TemplateLink("CSSSyntax")}} macro call below the title, and it will take care of the rest.</p>

<p>The only complication arises from making sure the data you need is present. The <a href="https://github.com/mdn/data/blob/master/css/properties.json">properties.json</a> file needs to contain an entry for the property you are documenting, and the <a href="https://github.com/mdn/data/blob/master/css/types.json">types.json</a> file needs to contain an entry for all of the value types used in the property's value.</p>

<p>You need to do this by forking the <a href="https://github.com/mdn/data">MDN data repo</a>, cloning your fork locally, making the changes in a new branch, then submitting a pull request against the upstream repo. You can <a href="/en-US/docs/MDN/Contribute/Structures/Compatibility_tables#Preparing_to_add_the_data">find more details about using Git here</a>.</p>

<h3 id="Selectors">Selectors</h3>

<p>The "Syntax" section of selector reference pages is much simpler than that of property pages. It contains one block styled using the "Syntax Box" style, which shows the basic syntax of the selector, whether it is just a simple keyword (e.g. {{CSSxRef(":hover")}}), or a more complex function value that takes a parameter (e.g. {{CSSxRef(":not", ":not()")}}). Sometimes the parameter is explained in a further entry inside the syntax block (see {{CSSxRef(":nth-last-of-type", ":nth-last-of-type()")}} for an example).</p>

<p>This block is automatically generated from the data included in the <a href="https://github.com/mdn/data">MDN data repo</a>'s CSS directory. You just need to include a {{TemplateLink("CSSSyntax")}} macro call below the title, and it will take care of the rest.</p>

<p>The only complication arises from making sure the data you need is present. The <a href="https://github.com/mdn/data/blob/master/css/selectors.json">selectors.json</a> file needs to contain an entry for the selector you are documenting.</p>

<p>You need to do this by forking the <a href="https://github.com/mdn/data">MDN data repo</a>, cloning your fork locally, making the changes in a new branch, then submitting a pull request against the upstream repo. You can <a href="/en-US/docs/MDN/Contribute/Structures/Compatibility_tables#Preparing_to_add_the_data">find more details about using Git here</a>.</p>

<h2 id="HTML_reference_syntax">HTML reference syntax</h2>

<p>HTML reference pages don't have "Syntax" sections — the syntax is always just the element name surrounded by angle brackets, so it isn't needed. the main thing you need to know about HTML elements is what attributes they take and what their values can be, and this is covered in a separate "Attributes" section. See {{htmlelement("ol")}} and {{htmlelement("video")}} for examples.</p>

<h2 id="HTTP_reference_syntax">HTTP reference syntax</h2>

<p>HTTP reference syntax is all manually created, and differs depending on what type of HTTP feature you are documenting.</p>

<h3 id="HTTP_headersContent-Security-Policy">HTTP headers/Content-Security-Policy</h3>

<p>HTTP header syntax (and Content-Security-Policy) is documented in two separate sections on the page — "Syntax" and "Directives".</p>

<h4 id="Syntax_section">Syntax section</h4>

<p>The "Syntax" section shows what a header's syntax will look like, using a syntax block styled using the "Syntax Box" style, including formal syntax to show exactly what directives can be included in the value, in what order, etc. For example, the {{HTTPHeader("If-None-Match")}} header's syntax block looks like this:</p>

<pre class="syntaxbox notranslate">If-None-Match: &lt;etag_value&gt;
If-None-Match: &lt;etag_value&gt;, &lt;etag_value&gt;, …
If-None-Match: *</pre>

<p>Some headers will have separate request directive, response directive, and extension syntax. If available, these must be incuded in separate syntax blocks, each under its own subsection. See {{HTTPHeader("Cache-Control")}} for an example.</p>

<h4 id="Directive_section">Directive section</h4>

<p>The "Directive" section contains a description list containing the names and descriptions of all the directives that can appear inside the syntax.</p>

<h3 id="HTTP_request_methods">HTTP request methods</h3>

<p>Request method syntax is really simple, just containing a syntax block styled using the "Syntax Box" style that shows how the method syntax is structured. The syntax for the <a href="/en-US/docs/Web/HTTP/Methods/GET">GET method</a> looks like this:</p>

<pre class="syntaxbox notranslate">GET /index.html</pre>

<h3 id="HTTP_response_status_codes">HTTP response status codes</h3>

<p>Again, the syntax for HTTP repsonse status codes is really simple — a syntax block including the code and name. For example:</p>

<pre class="syntaxbox notranslate">404 Not Found</pre>

<h2 id="SVG_reference_syntax">SVG reference syntax</h2>

<h3 id="SVG_elements">SVG elements</h3>

<p>SVG element syntax sections are non-existant — just like HTML element syntax sections. Each SVG element reference page just includes a list of the attributes that can apply to that element. See {{SVGElement("feTile")}} for example.</p>

<h3 id="SVG_attributes">SVG attributes</h3>

<p>SVG sttribute reference pages also do not include syntax sections.</p>
